OGRE-Next: Ogre::Decal Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Decal Class Referencefinal

Decals can have diffuse, normal map, and emissive on top of regular objects. More...

`#include <OgreDecal.h>`

Inheritance diagram for Ogre::Decal:
[legend]

## Public Member Functions
| Decal (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager)
| ~Decal () override
TextureGpu * | getDiffuseTexture () const
TextureGpu * | getEmissiveTexture () const
bool | getIgnoreAlphaDiffuse () const
float | getMetalness () const
const String & | getMovableType () const override
| Returns the type name of this object.
TextureGpu * | getNormalTexture () const
float | getRoughness () const
void | notifyTextureChanged (TextureGpu *texture, TextureGpuListener::Reason reason, void *extraData) override
| Called when a TextureGpu changed in a way that affects how it is displayed:
void | setDiffuseTexture (TextureGpu *diffuseTex)
| Call this family of functions if the input texture is automatically batched We will listen for residency changes and change the internal slice accordingly.
void | setDiffuseTextureRaw (TextureGpu *diffuseTex, uint32 sliceIdx)
| Call this family of functions if the input texture is managed by hand by you.
void | setEmissiveTexture (TextureGpu *emissiveTex)
void | setEmissiveTextureRaw (TextureGpu *emissiveTex, uint32 sliceIdx)
void | setIgnoreAlphaDiffuse (bool bIgnore)
| When diffuse textures are used (globally), the alpha component of the diffuse texture will be used to mask all the other textures (e.g.
void | setMetalness (float value)
| Value for Metalness. Must be in range [0; 1].
void | setNormalTexture (TextureGpu *normalTex)
void | setNormalTextureRaw (TextureGpu *normalTex, uint32 sliceIdx)
void | setRectSize (Vector2 planeDimensions, Real depth)
| Helper function to set width, height and depth of the decal.
void | setRenderQueueGroup (uint8 queueID) override
| Decals only allow ForwardPlusBase::MinDecalRq <= queueID < ForwardPlusBase::MaxDecalRq.
void | setRoughness (float roughness)
| Value for Roughness. Valid range depends on the BRDF used.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only).
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum().
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum().
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::TextureGpuListener
virtual | ~TextureGpuListener ()
virtual bool | shouldStayLoaded (TextureGpu *texture)
| Return true if this TextureGpu should likely stay loaded or else graphical changes could occur.

## Public Attributes
uint16 | mDiffuseIdx
uint16 | mEmissiveIdx
uint16 | mIgnoreDiffuseAlpha
float | mMetalness
uint16 | mNormalMapIdx
float | mRoughness
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables

## Additional Inherited Members
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Types inherited from Ogre::TextureGpuListener
enum | Reason { Unknown , FromStorageToSysRam , FromSysRamToStorage , GainedResidency , LostResidency , PoolTextureSlotChanged , ResidentToSysRamSync , MetadataCacheOutOfDate , ExceptionThrown , FsaaSettingAlteredByApi , ReadyForRendering , Deleted }
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Decals can have diffuse, normal map, and emissive on top of regular objects.

You can GLOBALLY disable each of these (diffuse/normal/emissive) by setting a null texture in SceneManager::setDecalsDiffuse and co.

If a nullptr is set on e.g. Normal textures, and a Decal uses normal maps, they won't appear. You need to set a valid pointer to SceneManager::setDecalsNormals.

Likewise, if no Decal actually uses normal textures, but you still set one via SceneManager::setDecalsNormals, then you will be wasting GPU shader performance.

When diffuse is used, the fresnel and specular colours of the material are overwritten as well.

Q: How to disable diffuse/normal/emissive per Decal?

To disable diffuse just point to a diffuse texture slice (mDiffuseIdx) that is a black and call setIgnoreAlphaDiffuse( true )
To disable normals, just point to a normal map that has XY components set both to 0
To disable emissive, just point to a texture that is black.

Q: Why does it use Metalness? What happens when a non-metallic workflow is used?

Metalness is used for performance reasons, as it allows giving enough control over the specular by just using one parameter, rather than having 3 (one per specular channel)

On metallic & fresnel workflows, this "just works" because the metalness parameter will produce a new coloured F0 parameter, which will overwrite the one from the original material.

On specular workflows, if the fresnel is coloured, it will behave the same way as a metallic/fresnel workflow, because the original specular colour will be set to white, and F0 will be overwritten.

If the fresnel is monochrome (specular workflow), then the specular colour will be overwritten instead, and the metalness value of the decal will act as a fresnel value, overwriting the original fresnel.

## Constructor & Destructor Documentation

## ◆ Decal()

Ogre::Decal::Decal | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager )

## ◆ ~Decal()

Ogre::Decal::~Decal | ( |  | ) |
| override

## Member Function Documentation

## ◆ getDiffuseTexture()

TextureGpu * Ogre::Decal::getDiffuseTexture | ( |  | ) | const

## ◆ getEmissiveTexture()

TextureGpu * Ogre::Decal::getEmissiveTexture | ( |  | ) | const

## ◆ getIgnoreAlphaDiffuse()

bool Ogre::Decal::getIgnoreAlphaDiffuse | ( |  | ) | const

## ◆ getMetalness()

float Ogre::Decal::getMetalness | ( |  | ) | const
| inline

References mMetalness.

## ◆ getMovableType()

const String & Ogre::Decal::getMovableType | ( |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getNormalTexture()

TextureGpu * Ogre::Decal::getNormalTexture | ( |  | ) | const

## ◆ getRoughness()

float Ogre::Decal::getRoughness | ( |  | ) | const
| inline

References mRoughness.

## ◆ notifyTextureChanged()

void Ogre::Decal::notifyTextureChanged | ( | TextureGpu * | texture,
|  | TextureGpuListener::Reason | reason,
|  | void * | extraData )
| overridevirtual

Called when a TextureGpu changed in a way that affects how it is displayed:

1. TextureGpu::notifyDataIsReady got called (texture is ready to be displayed)
2. Texture changed residency status.
3. Texture is being deleted. It won't be a valid pointer after this call.

Implements Ogre::TextureGpuListener.

## ◆ setDiffuseTexture()

void Ogre::Decal::setDiffuseTexture | ( | TextureGpu * | diffuseTex | ) |

Call this family of functions if the input texture is automatically batched We will listen for residency changes and change the internal slice accordingly.

## ◆ setDiffuseTextureRaw()

void Ogre::Decal::setDiffuseTextureRaw | ( | TextureGpu * | diffuseTex,
|  | uint32 | sliceIdx )

Call this family of functions if the input texture is managed by hand by you.

We will not listen to residency changes. It's your responsibility to ensure the texture resident by the time it needs to be displayed.

## ◆ setEmissiveTexture()

void Ogre::Decal::setEmissiveTexture | ( | TextureGpu * | emissiveTex | ) |

## ◆ setEmissiveTextureRaw()

void Ogre::Decal::setEmissiveTextureRaw | ( | TextureGpu * | emissiveTex,
|  | uint32 | sliceIdx )

## ◆ setIgnoreAlphaDiffuse()

void Ogre::Decal::setIgnoreAlphaDiffuse | ( | bool | bIgnore | ) |

When diffuse textures are used (globally), the alpha component of the diffuse texture will be used to mask all the other textures (e.g.

normal & emissive maps).

When bIgnore = true, the alpha component of the diffuse texture won't be used on normal & emissive maps.

Parameters

  bIgnore | True to ignore the alpha on the other maps. False otherwise. Default: False

## ◆ setMetalness()

void Ogre::Decal::setMetalness | ( | float | value | ) |

Value for Metalness. Must be in range [0; 1].

## ◆ setNormalTexture()

void Ogre::Decal::setNormalTexture | ( | TextureGpu * | normalTex | ) |

## ◆ setNormalTextureRaw()

void Ogre::Decal::setNormalTextureRaw | ( | TextureGpu * | normalTex,
|  | uint32 | sliceIdx )

## ◆ setRectSize()

void Ogre::Decal::setRectSize | ( | Vector2 | planeDimensions,
|  | Real | depth )

Helper function to set width, height and depth of the decal.

This is a helper function because these parameters actually live in the parent scene node

All the function does is literally:

if( mParentNode )
mParentNode->setScale( planeDimensions.x, depth, planeDimensions.y );

Parameters

  planeDimensions | planeDimensions.x = width planeDimensions.y = height
  depth | Decals are 2D by nature. The depth of the decal indicates its influence on the objects. Decals are like oriented boxes, and everything inside the box will be affected by the decal.

## ◆ setRenderQueueGroup()

void Ogre::Decal::setRenderQueueGroup | ( | uint8 | queueID | ) |
| overridevirtual

Decals only allow ForwardPlusBase::MinDecalRq <= queueID < ForwardPlusBase::MaxDecalRq.

Reimplemented from Ogre::MovableObject.

## ◆ setRoughness()

void Ogre::Decal::setRoughness | ( | float | roughness | ) |

Value for Roughness. Valid range depends on the BRDF used.

## Member Data Documentation

## ◆ mDiffuseIdx

uint16 Ogre::Decal::mDiffuseIdx

## ◆ mEmissiveIdx

uint16 Ogre::Decal::mEmissiveIdx

## ◆ mIgnoreDiffuseAlpha

uint16 Ogre::Decal::mIgnoreDiffuseAlpha

## ◆ mMetalness

float Ogre::Decal::mMetalness

Referenced by getMetalness().

## ◆ mNormalMapIdx

uint16 Ogre::Decal::mNormalMapIdx

## ◆ mRoughness

float Ogre::Decal::mRoughness

Referenced by getRoughness().

The documentation for this class was generated from the following file:

- OgreDecal.h